#include <gridtools/fn/backend/gpu.hpp>
#include <gridtools/sid/dimension_to_tuple_like.hpp>
#include <gridtools/stencil/global_parameter.hpp>

#include <cmath>
#include <cstdint>
#include <functional>
#include <gridtools/fn/sid_neighbor_table.hpp>
#include <gridtools/fn/unstructured.hpp>

namespace generated {

namespace gtfn = ::gridtools::fn;

namespace {
using namespace ::gridtools::literals;

using Vertex_t = gtfn::unstructured::dim::horizontal;
constexpr inline Vertex_t Vertex{};

using K_t = gtfn::unstructured::dim::vertical;
constexpr inline K_t K{};

struct V2V_t {};
constexpr inline V2V_t V2V{};

struct V2E_t {};
constexpr inline V2E_t V2E{};

using Edge_t = gtfn::unstructured::dim::horizontal;
constexpr inline Edge_t Edge{};

struct E2V_t {};
constexpr inline E2V_t E2V{};

using Koff_t = K_t;
constexpr inline Koff_t Koff{};

struct _fun_1 {
  constexpr auto operator()() const {
    return [](auto const &x) { return gtfn::deref(x); };
  }
};

using block_sizes_t = gridtools::meta::list<
    gridtools::meta::list<gtfn::unstructured::dim::horizontal,
                          gridtools::integral_constant<int, 32>>,
    gridtools::meta::list<gtfn::unstructured::dim::vertical,
                          gridtools::integral_constant<int, 8>>>;

inline auto __field_operator__velocity_backup = [](auto... connectivities__) {
  return [connectivities__...](auto backend, auto &&__sym_1, auto &&out,
                               auto &&____sym_1_size_0, auto &&____sym_1_size_1,
                               auto &&__out_size_0, auto &&__out_size_1) {
    auto tmp_alloc__ = gtfn::backend::tmp_allocator(backend);

    make_backend(backend,
                 gtfn::unstructured_domain(
                     ::gridtools::tuple((__out_size_0 - 0), (__out_size_1 - 0)),
                     ::gridtools::tuple(0, 0), connectivities__...))
        .stencil_executor()()
        .arg(out)
        .arg(__sym_1)
        .assign(0_c, _fun_1(), 1_c)
        .execute();
  };
};
} // namespace
} // namespace generated

template <class BufferT0, class BufferT1, class BufferT6, class BufferT7,
          class BufferT8>
decltype(auto) __field_operator__velocity_backup(
    BufferT0 &&__sym_1, BufferT1 &&out, std::int32_t ____sym_1_size_0,
    std::int32_t ____sym_1_size_1, std::int32_t __out_size_0,
    std::int32_t __out_size_1, BufferT6 &&gt_conn_v2v, BufferT7 &&gt_conn_v2e,
    BufferT8 &&gt_conn_e2v) {
  return generated::__field_operator__velocity_backup(
      gridtools::hymap::keys<generated::V2V_t>::make_values(
          gridtools::fn::sid_neighbor_table::as_neighbor_table<
              generated::Vertex_t, generated::V2V_t, 6>(
              std::forward<decltype(gt_conn_v2v)>(gt_conn_v2v))),
      gridtools::hymap::keys<generated::V2E_t>::make_values(
          gridtools::fn::sid_neighbor_table::as_neighbor_table<
              generated::Vertex_t, generated::V2E_t, 6>(
              std::forward<decltype(gt_conn_v2e)>(gt_conn_v2e))),
      gridtools::hymap::keys<generated::E2V_t>::make_values(
          gridtools::fn::sid_neighbor_table::as_neighbor_table<
              generated::Edge_t, generated::E2V_t, 2>(
              std::forward<decltype(gt_conn_e2v)>(gt_conn_e2v))))(
      gridtools::fn::backend::gpu<generated::block_sizes_t>{},
      std::forward<decltype(__sym_1)>(__sym_1),
      std::forward<decltype(out)>(out),
      std::forward<decltype(____sym_1_size_0)>(____sym_1_size_0),
      std::forward<decltype(____sym_1_size_1)>(____sym_1_size_1),
      std::forward<decltype(__out_size_0)>(__out_size_0),
      std::forward<decltype(__out_size_1)>(__out_size_1));
}