#include "__field_operator__velocity_backup.cuh"

#include <gridtools/common/defs.hpp>
#include <gridtools/common/tuple_util.hpp>
#include <gridtools/fn/cartesian.hpp>
#include <gridtools/fn/unstructured.hpp>
#include <gridtools/sid/composite.hpp>
#include <gridtools/sid/rename_dimensions.hpp>
#include <gridtools/sid/unknown_kind.hpp>
#include <gridtools/storage/adapter/nanobind_adapter.hpp>
#include <nanobind/nanobind.h>
#include <nanobind/ndarray.h>
#include <nanobind/stl/pair.h>
#include <nanobind/stl/tuple.h>

decltype(auto) __field_operator__velocity_backup_wrapper(
    std::tuple<
        std::pair<nanobind::ndarray<
                      double, nanobind::shape<nanobind::any, nanobind::any>>,
                  std::tuple<ptrdiff_t, ptrdiff_t>>,
        std::pair<nanobind::ndarray<
                      double, nanobind::shape<nanobind::any, nanobind::any>>,
                  std::tuple<ptrdiff_t, ptrdiff_t>>,
        std::pair<nanobind::ndarray<
                      double, nanobind::shape<nanobind::any, nanobind::any>>,
                  std::tuple<ptrdiff_t, ptrdiff_t>>>
        __sym_1,
    std::tuple<
        std::pair<nanobind::ndarray<
                      double, nanobind::shape<nanobind::any, nanobind::any>>,
                  std::tuple<ptrdiff_t, ptrdiff_t>>,
        std::pair<nanobind::ndarray<
                      double, nanobind::shape<nanobind::any, nanobind::any>>,
                  std::tuple<ptrdiff_t, ptrdiff_t>>,
        std::pair<nanobind::ndarray<
                      double, nanobind::shape<nanobind::any, nanobind::any>>,
                  std::tuple<ptrdiff_t, ptrdiff_t>>>
        out,
    std::int32_t ____sym_1_size_0, std::int32_t ____sym_1_size_1,
    std::int32_t __out_size_0, std::int32_t __out_size_1,
    std::pair<nanobind::ndarray<std::int32_t,
                                nanobind::shape<nanobind::any, nanobind::any>>,
              std::tuple<ptrdiff_t, ptrdiff_t>>
        gt_conn_v2v,
    std::pair<nanobind::ndarray<std::int32_t,
                                nanobind::shape<nanobind::any, nanobind::any>>,
              std::tuple<ptrdiff_t, ptrdiff_t>>
        gt_conn_v2e,
    std::pair<nanobind::ndarray<std::int32_t,
                                nanobind::shape<nanobind::any, nanobind::any>>,
              std::tuple<ptrdiff_t, ptrdiff_t>>
        gt_conn_e2v) {
  return __field_operator__velocity_backup(
      gridtools::sid::composite::keys<gridtools::integral_constant<int, 0>,
                                      gridtools::integral_constant<int, 1>,
                                      gridtools::integral_constant<int, 2>>::
          make_values(
              gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                         generated::K_t>(
                  gridtools::sid::shift_sid_origin(
                      gridtools::nanobind::as_sid(
                          gridtools::tuple_util::get<0>(__sym_1).first),
                      gridtools::tuple_util::get<0>(__sym_1).second)),
              gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                         generated::K_t>(
                  gridtools::sid::shift_sid_origin(
                      gridtools::nanobind::as_sid(
                          gridtools::tuple_util::get<1>(__sym_1).first),
                      gridtools::tuple_util::get<1>(__sym_1).second)),
              gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                         generated::K_t>(
                  gridtools::sid::shift_sid_origin(
                      gridtools::nanobind::as_sid(
                          gridtools::tuple_util::get<2>(__sym_1).first),
                      gridtools::tuple_util::get<2>(__sym_1).second))),
      gridtools::sid::composite::keys<gridtools::integral_constant<int, 0>,
                                      gridtools::integral_constant<int, 1>,
                                      gridtools::integral_constant<int, 2>>::
          make_values(
              gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                         generated::K_t>(
                  gridtools::sid::shift_sid_origin(
                      gridtools::nanobind::as_sid(
                          gridtools::tuple_util::get<0>(out).first),
                      gridtools::tuple_util::get<0>(out).second)),
              gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                         generated::K_t>(
                  gridtools::sid::shift_sid_origin(
                      gridtools::nanobind::as_sid(
                          gridtools::tuple_util::get<1>(out).first),
                      gridtools::tuple_util::get<1>(out).second)),
              gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                         generated::K_t>(
                  gridtools::sid::shift_sid_origin(
                      gridtools::nanobind::as_sid(
                          gridtools::tuple_util::get<2>(out).first),
                      gridtools::tuple_util::get<2>(out).second))),
      ____sym_1_size_0, ____sym_1_size_1, __out_size_0, __out_size_1,
      gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                 generated::V2V_t>(
          gridtools::sid::shift_sid_origin(
              gridtools::nanobind::as_sid(gt_conn_v2v.first),
              gt_conn_v2v.second)),
      gridtools::sid::rename_numbered_dimensions<generated::Vertex_t,
                                                 generated::V2E_t>(
          gridtools::sid::shift_sid_origin(
              gridtools::nanobind::as_sid(gt_conn_v2e.first),
              gt_conn_v2e.second)),
      gridtools::sid::rename_numbered_dimensions<
          generated::Edge_t, generated::E2V_t>(gridtools::sid::shift_sid_origin(
          gridtools::nanobind::as_sid(gt_conn_e2v.first), gt_conn_e2v.second)));
}

NB_MODULE(__field_operator__velocity_backup, module) {
  module.doc() = "";
  module.def("__field_operator__velocity_backup",
             &__field_operator__velocity_backup_wrapper, "");
}